/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 0  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"

extern short int config[MAX_MODULE];
extern pid_t pid[MAX_MODULE];
extern union {
		MODUL_DO modul_do;
		MODUL_AO modul_ao;
		MODUL_AI modul_ai;
		MODUL_DI modul_di;
		MODUL_FI modul_fi;
		} modul[8];

int
slider_move( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
	{
	register char i,k;
	float j;
	PtArg_t arg[1];
	char buf[15];
	MODUL_AO * pmodul_ao;
	MESAJ_AO mesaj_ao;

	for(i=0;i<8;i++)
		if(config[i]==AO)
			{
			if(modul[i].modul_ao.dialog && ApGetInstance(widget)==modul[i].modul_ao.window_instance)
				{
				j=((PtSliderCallback_t*)cbinfo->cbdata)->position/10.;
				break;
				}
			}
	pmodul_ao=&modul[i].modul_ao;

	/* ai aflat ca este modulul j , acum afli care slider din cele 6 a fost implicat */
	for(k=0;k<6;k++) if(pmodul_ao->slider_setari_ao[k]==widget) break;

	sprintf(buf,"%2.1f",j);
	PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(pmodul_ao->text_setari_ao[k],1,arg);

	PtSetArg(&arg[0],Pt_ARG_FILL_COLOR,APRINS,0);
	PtSetResources(pmodul_ao->active,1,arg);
	PtFlush();

	mesaj_ao.output=k;
	mesaj_ao.value=j;
	
	PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(pmodul_ao->texte_valori[k],1,arg);
	pmodul_ao->v_AO[k]=j;

	Send(pid[i],&mesaj_ao,0,sizeof(MESAJ_AO),0);

	PtSetArg(&arg[0],Pt_ARG_FILL_COLOR,STINS,0);
	PtSetResources(pmodul_ao->active,1,arg);

	return( Pt_CONTINUE );

	}


int
auto_ao( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i,j,r;
	PtArg_t arg[1];

	for(i=0;i<8;i++)
		if(config[i]==AO)
			{
			if(modul[i].modul_ao.dialog && ApGetInstance(widget)==modul[i].modul_ao.window_instance)
				{
				j=((PtOnOffButtonCallback_t*)cbinfo->cbdata)->state;
				break;
				}
			}
	/* trimiti semnal catre pid[i] */
	kill(pid[i],SIGUSR2);
	modul[i].modul_ao.flag_auto^=1;

	if(j==0) /* faci cele 6 slidere selectabile */
		{
		PtSetArg(&arg[0],Pt_ARG_FLAGS,Pt_SELECTABLE|Pt_HIGHLIGHTED,0xffffffff);
		for(r=0;r<6;r++)
		  PtSetResources(modul[i].modul_ao.slider_setari_ao[r],1,arg);
		}
	else /* faci cele 6 slidere neselectabile */
		{
		PtSetArg(&arg[0],Pt_ARG_FLAGS,Pt_BLOCKED,0xffffffff);
		for(r=0;r<6;r++)
		  PtSetResources(modul[i].modul_ao.slider_setari_ao[r],1,arg);
		}


	return( Pt_CONTINUE );
	}

int
auto_do( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i,j,r;
	PtArg_t arg[1];
	MODUL_DO *pmodul_do;

	for(i=0;i<8;i++)
		if(config[i]==DO)
			{
			if(modul[i].modul_do.dialog && ApGetInstance(widget)==modul[i].modul_do.window_instance)
				{
				j=((PtOnOffButtonCallback_t*)cbinfo->cbdata)->state;
				break;
				}
			}
	/* trimiti semnal catre pid[i] */
	kill(pid[i],SIGUSR2);
	modul[i].modul_do.flag_auto^=1;

	pmodul_do=&modul[i].modul_do;
	if(j==0) /* faci cele 24 de butoane on/off selectabile */
		{
		PtSetArg(&arg[0],Pt_ARG_FLAGS,Pt_SELECTABLE|Pt_HIGHLIGHTED,0xffffffff);
		for(r=0;r<24;r++)
		  	PtSetResources(pmodul_do->buton_setari_do[r],1,arg);
		}
	else /* faci cele 24 de butoane on/off neselectabile */
		{
		PtSetArg(&arg[0],Pt_ARG_FLAGS,Pt_HIGHLIGHTED,0xffffffff);
		for(r=0;r<24;r++)
		  PtSetResources(modul[i].modul_do.buton_setari_do[r],1,arg);
		}

	return( Pt_CONTINUE );

	}

int
stare_do( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i,j,k;
	MESAJ_DO mesaj_do;
	MODUL_DO *pmodul_do;
	PtArg_t arg[1];

	for(i=0;i<8;i++)
		if(config[i]==DO)
			{
			if(modul[i].modul_do.dialog && ApGetInstance(widget)==modul[i].modul_do.window_instance)
				{
				j=((PtOnOffButtonCallback_t*)cbinfo->cbdata)->state;
				break;
				}
			}

	pmodul_do=&modul[i].modul_do;
	/* ai aflat ca este modulul j , acum afli care buton on/off din cele 24 a fost implicat */
	for(k=0;k<24;k++) if(pmodul_do->buton_setari_do[k]==widget) break;

 	PtSetArg(&arg[0],Pt_ARG_FILL_COLOR,APRINS,0);
	PtSetResources(pmodul_do->io,1,arg);
	PtFlush();
	
	mesaj_do.output=k;
	mesaj_do.value=j;

	pmodul_do->v_DO[k]=j;
	PtSetArg(&arg[0],Pt_ARG_FILL_COLOR,j?VALOARE_1:VALOARE_0,0);
	PtSetResources(pmodul_do->bec[k],1,arg);

	Send(pid[i],&mesaj_do,0,sizeof(MESAJ_DO),0);

	PtSetArg(&arg[0],Pt_ARG_FILL_COLOR,STINS,0);
	PtSetResources(pmodul_do->io,1,arg);
	
	return( Pt_CONTINUE );
	}
int
next_ai( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i,k,r;
	PtArg_t arg[1];
	char buf[20];

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	for(i=0;i<8;i++)
		if(config[i]==AI)
			if(modul[i].modul_ai.dialog && ApGetInstance(widget)==modul[i].modul_ai.window_instance)
				break;

	modul[i].modul_ai.start=(modul[i].modul_ai.start+6)%24;

	for(k=0;k<6;k++)
		{
		sprintf(buf,"Channel %d",k+modul[i].modul_ai.start);
		PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
		PtSetResources(ApGetWidgetPtr(ApGetInstance(widget),
			k==0?ABN_c0:k==1?ABN_c1:k==2?ABN_c2:k==3?ABN_c3:k==4?ABN_c4:ABN_c5),
			1,arg);
		}

	for(k=0;k<6;k++)
		for(r=0;r<MAX_DATA;r++)
			modul[i].modul_ai.buffer_data[k][r]=0;

	return( Pt_CONTINUE );


	}

int
next_di( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i,k,r;
	PtArg_t arg[1];
	char buf[20];
	MODUL_DI * pmodul_di;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	for(i=0;i<8;i++)
		if(config[i]==DI)
			if(modul[i].modul_di.dialog && ApGetInstance(widget)==modul[i].modul_di.window_instance)
				break;

	pmodul_di=&modul[i].modul_di;

	pmodul_di->start=(pmodul_di->start+6)%24;

	for(k=0;k<6;k++)
		{
		sprintf(buf,"Ch%2d",k+pmodul_di->start);
		PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
		PtSetResources(ApGetWidgetPtr(ApGetInstance(widget),
			k==0?ABN_di_ch0:k==1?ABN_di_ch1:k==2?ABN_di_ch2:k==3?ABN_di_ch3:k==4?
				ABN_di_ch4:ABN_di_ch5),
			1,arg);
		}

	for(k=0;k<6;k++)
		{
		for(r=0;r<MAX_POINTS_DI;r++)
			pmodul_di->old_buffer_data[k][r]=pmodul_di->buffer_data[k][r];
		for(r=0;r<MAX_POINTS_DI-1;r++)
			pmodul_di->buffer_data[k][r]=0;
		pmodul_di->buffer_data[k][r]=pmodul_di->v_DI[pmodul_di->start+k];
		}

	pmodul_di->redraw=-2;
	PtDamageWidget(pmodul_di->raw);
	PtFlush();

	return( Pt_CONTINUE );
	}
