#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/qnxterm.h>
#include <fcntl.h>
#include <unistd.h>
#include <process.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>

#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

#include "proto.h"


pid_t pid[MAX_MODULE];
short int config[MAX_MODULE]={-1,-1,-1,-1,-1,-1,-1,-1}; /* config[i]=AO/DO/DI/AI/FI */

union {
	MODUL_DO modul_do;
	MODUL_AO modul_ao;
	MODUL_AI modul_ai;
	MODUL_DI modul_di;
	MODUL_FI modul_fi;
	} modul[8];

void configurare()
{ register i;
  char buf[20];
  char tipuri_cod[8]={AI,AI,DO,AO,DO,AO,FI,DI};

for(i=0;i<8;i++)
{
sprintf(buf,"%d",i);
switch(tipuri_cod[i])
{
case AO:
	config[i]=AO;
  	pid[i]=spawnl(P_NOWAIT,"/PHOTON/usp/src/PROC/proc_ao","proc_ao",buf,NULL);
  	if(pid[i]==-1)	{ fprintf(stderr,"Error spawnl /PHOTON/usp/src/PROC/proc_ao\n");
				  exit(0);
			}
	break;

case DO:
	config[i]=DO;
  	pid[i]=spawnl(P_NOWAIT,"/PHOTON/usp/src/PROC/proc_do","proc_do",buf,NULL);
  	if(pid[i]==-1)	{ fprintf(stderr,"Error spawnl /PHOTON/usp/src/PROC/proc_do\n");
				  exit(0);
			}
	break;

case DI:
	config[i]=DI;
  	pid[i]=spawnl(P_NOWAIT,"/PHOTON/usp/src/PROC/proc_di","proc_di",buf,NULL);
  	if(pid[i]==-1)	{ fprintf(stderr,"Error spawnl /PHOTON/usp/src/PROC/proc_di\n");
				  exit(0);
			}
	break;

case AI:
	config[i]=AI;
  	pid[i]=spawnl(P_NOWAIT,"/PHOTON/usp/src/PROC/proc_ai","proc_ai",buf,NULL);
  	if(pid[i]==-1)	{ fprintf(stderr,"Error spawnl /PHOTON/usp/src/PROC/proc_ai\n");
				  exit(0);
			}
	break;

case FI:
	config[i]=FI;
  	pid[i]=spawnl(P_NOWAIT,"/PHOTON/usp/src/PROC/proc_fi","proc_fi",buf,NULL);
  	if(pid[i]==-1)	{ fprintf(stderr,"Error spawnl /PHOTON/usp/src/PROC/proc_fi\n");
				  exit(0);
			}
	break;

}
}

/* inainte de a lansa procesele de achizitie , furnizezi un punct de intrare pentru mesajele lor */
(void)PtAppAddInput(NULL,(pid_t)0,handler,0);


init_ecran();
}

/* pregatesti ecranul */

void init_ecran()
{
register short int i;
/* afiseaza pe ecran modulele in functie de configuratie */
for(i=0;i<8;i++)
  switch(config[i]) {
	case AO:
		init_AO(i,&modul[i].modul_ao);
		break;
	case DO:
		init_DO(i,&modul[i].modul_do);
		break;
	case DI:
		init_DI(i,&modul[i].modul_di);
		break;
	case AI:
		init_AI(i,&modul[i].modul_ai);
		break;
	case FI:
		init_FI(i,&modul[i].modul_fi);
		break;
	default:
		break;
	}
}



int handler(void *client_data,pid_t pid,void *msg,size_t msglen)
{
MESAJ_GEN *pmesaj_gen;

pmesaj_gen=(MESAJ_GEN*)msg;

switch(pmesaj_gen->tip)
{
case AO:
	afiseaza_AO_1(&modul[pmesaj_gen->rezervat].modul_ao,(MESAJ_AO*)&pmesaj_gen->mess);
	Reply(pid,0,0);
        break;

case DO:
	afiseaza_DO_1(&modul[pmesaj_gen->rezervat].modul_do,(MESAJ_DO*)&pmesaj_gen->mess);
	Reply(pid,0,0);
        break;

case DI:
        afiseaza_DI_1(&modul[pmesaj_gen->rezervat].modul_di,(MESAJ_DI*)&pmesaj_gen->mess);
	Reply(pid,0,0);
        break;

case DI24:
        afiseaza_DI(&modul[pmesaj_gen->rezervat].modul_di,(struct d*)&pmesaj_gen->mess);
	Reply(pid,0,0);
        break;

case AI:
        afiseaza_AI(&modul[pmesaj_gen->rezervat].modul_ai,(MESAJ_AI*)&pmesaj_gen->mess);
	Reply(pid,0,0);
        break;

case FI:
        afiseaza_FI(&modul[pmesaj_gen->rezervat].modul_fi,(MESAJ_FI*)&pmesaj_gen->mess);
	Reply(pid,0,0);
        break;

case BEC_AO:
	bec_AO(&modul[pmesaj_gen->rezervat].modul_ao);
	Reply(pid,0,0);
        break;

case BEC_DO:
	bec_DO(&modul[pmesaj_gen->rezervat].modul_do);
	Reply(pid,0,0);
        break;

case BEC_FI:
        bec_FI(&modul[pmesaj_gen->rezervat].modul_fi);
	Reply(pid,0,0);
        break;
}


return Pt_CONTINUE;
}
