#include <Ph.h>
#include <Pt.h>
#include <Ap.h>
#include <unistd.h>
#include <sys/kernel.h>

/* message from proc_do to usp */
typedef struct {
  int output;
  int value;
	} MESAJ_DO;

/* message from proc_ao to usp */
typedef struct {
  int output;
  float value;
	} MESAJ_AO;

/* message from proc_ai to usp */
typedef struct {
  unsigned short int value[24];
  } MESAJ_AI;

/* message from proc_di to usp */
typedef struct {
  char line;
  char value;
  } MESAJ_DI;

/* message from proc_fi to usp */
typedef struct {
  unsigned long int v[16];
  } MESAJ_FI;


#define AO			1
#define DO			2
#define DI			3
#define AI 			4
#define FI			5

#define DI24			15

#define BEC_AO			16
#define BEC_DO			17
#define BEC_FI			18

#define APRINS			Pg_RED
#define STINS			Pg_DGRAY
#define VALOARE_1		Pg_RED
#define VALOARE_0		Pg_GRAY

#define MAX_DATA		60
#define MAX_POINTS_DI		16

#define MAX_MODULE		8


struct d { char value[24];
	 };

typedef struct { char tip;
		 char rezervat;
		 char mess[100];
		} MESAJ_GEN;

/* DO-124 */
typedef struct {
		char v_DO[24];
		PtWidget_t * baza_imagine; /* imaginea de baza PtLabel */
		PtWidget_t * marca, *ice; /* butonul cu textul DO-124 */
		PtWidget_t * bec[24],*io,*act;
		char dialog; /* flag */
		PtWidget_t * window_instance,*buton_setari_do[24];
		char flag_auto;
		} MODUL_DO;

/* AO-106 */
typedef struct {
		float v_AO[6];
		PtWidget_t * baza_imagine; /* imaginea de baza PtLabel */
		PtWidget_t * marca, *ice; /* butonul cu textul AO-106 */
		PtWidget_t * active;
		PtWidget_t *baza_texte_valori;
		PtWidget_t * texte_valori[6];
		char dialog; /* flag */
		PtWidget_t * window_instance,*text_setari_ao[6],*slider_setari_ao[6];
		char flag_auto;
		} MODUL_AO;

/* AI-124 */
typedef struct {
		float v_AI[24];
		char inceput_afisaj; /* se afiseaza pe modul inceput_afisaj...inceput_afisaj+3 */
		PtWidget_t * text_interval_valori[4]; /* textele Ch0 Ch1 etc ... */
		PtWidget_t * baza_imagine; /* imaginea de baza PtLabel */
		PtWidget_t * marca, *ice; /* butonul cu textul AI-124 */
		PtWidget_t * io;
		PtWidget_t * baza_texte_valori;
		PtWidget_t * texte_valori[4]; /* am loc doar pentru 4 */
		char dialog; /* flag */
		PtWidget_t * window_instance,*rt[6];
		int start;
		short int buffer_data[6][MAX_DATA];
		} MODUL_AI;

/* DI-124 */
typedef struct {
		char v_DI[24];
		PtWidget_t * baza_imagine; /* imaginea de baza PtLabel */
		PtWidget_t * marca, *ice; /* butonul cu textul DO-124 */
		PtWidget_t * bec_valori[24],*io,*act;
		char dialog; /* flag */
		PtWidget_t * window_instance,*raw;
		int start;
		short int redraw; /* -1=all graphics , 0...5 = graphic #0...5 */
		short int buffer_data[6][MAX_POINTS_DI];
		short int old_buffer_data[6][MAX_POINTS_DI];
		} MODUL_DI;

/* FI-116 */
typedef struct {
		unsigned long v_FI[16];
		char inceput_afisaj; /* se afiseaza pe modul inceput_afisaj...inceput_afisaj+7 */
		PtWidget_t * text_interval_valori; /* textul Ch 0 - 7  etc... */
		PtWidget_t * baza_imagine; /* imaginea de baza PtLabel */
		PtWidget_t * marca, *ice; /* butonul cu textul AI-124 */
		PtWidget_t * io;
		PtWidget_t * baza_texte_valori;
		PtWidget_t * texte_valori[8]; /* am loc doar pentru 4 */
		
		char dialog; /* flag */
		PtWidget_t * window_instance,*text_scale[11],*bar[16];
		} MODUL_FI;
