/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 0  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>
#include <photon/PxHelp.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"

extern pid_t pid[MAX_MODULE];
extern int n_module[5];

extern short int config[MAX_MODULE];

extern union {
		MODUL_DO modul_do;
		MODUL_AO modul_ao;
		MODUL_AI modul_ai;
		MODUL_DI modul_di;
		MODUL_FI modul_fi;
		} modul[8];

static int pozitia_modul_setari;

int quit( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
register char i;

/* eliminate 'unreferenced' warnings */
widget = widget, apinfo = apinfo, cbinfo = cbinfo;

for(i=0;i<8;i++) kill(pid[i],9);

exit(0);
}

int
initializare( int argc, char *argv[] )

	{

	/* eliminate 'unreferenced' warnings */
	argc = argc, argv = argv;

	configurare();

	return( Pt_CONTINUE );

	}

void buton_apasat(PtWidget_t *widget,void *pozitia ,PtCallbackInfo_t *cbinfo)
{
register char i,r;
PtArg_t arg[4];
MODUL_AO * pmodul_ao;
MODUL_DO * pmodul_do;
MODUL_AI * pmodul_ai;
MODUL_DI * pmodul_di;
MODUL_FI * pmodul_fi;
char buf[25];

i=(int)pozitia;

switch(config[i])
{
case AO:
	pmodul_ao=&modul[i].modul_ao;
	pozitia_modul_setari=i;

	if(!pmodul_ao->dialog) /* nu are deja un dialog */
		{
		pmodul_ao->dialog=1;
		ApCreateModule(ABM_setari_ao,NULL,NULL);
		}
	else
		PtWindowToFront(pmodul_ao->window_instance);

	break;
case DO:
	pmodul_do=&modul[i].modul_do;

	pozitia_modul_setari=i;
	if(!pmodul_do->dialog) /* nu are deja un dialog */
		{
		pmodul_do->dialog=1;
		ApCreateModule(ABM_setari_do,NULL,NULL);
		}
	else
		PtWindowToFront(pmodul_do->window_instance);

	break;
case AI:
	pmodul_ai=&modul[i].modul_ai;

	pmodul_ai->inceput_afisaj+=4;
	if(pmodul_ai->inceput_afisaj==24) pmodul_ai->inceput_afisaj=0;

	for(r=0;r<4;r++)
		{
		sprintf(buf,"V%d",r+pmodul_ai->inceput_afisaj);
		PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
		PtSetResources(pmodul_ai->text_interval_valori[r],1,arg);
		}

	pune_valori_AI(pmodul_ai);


	pozitia_modul_setari=i;
	if(!pmodul_ai->dialog) /* nu are deja un dialog */
		{
		pmodul_ai->dialog=1;
		ApCreateModule(ABM_setari_ai,NULL,NULL);
		}
	else
		PtWindowToFront(pmodul_ai->window_instance);
	break;
case DI:
	pmodul_di=&modul[i].modul_di;

	pozitia_modul_setari=i;
	if(!pmodul_di->dialog) /* nu are deja un dialog */
		{
		pmodul_di->dialog=1;
		ApCreateModule(ABM_setari_di,NULL,NULL);
		}
	else
		PtWindowToFront(pmodul_di->window_instance);
	break;
case FI:
	pmodul_fi=&modul[i].modul_fi;

	pmodul_fi->inceput_afisaj+=8;
	if(pmodul_fi->inceput_afisaj==16) pmodul_fi->inceput_afisaj=0;

	sprintf(buf,"Ch%2d-%2d",pmodul_fi->inceput_afisaj,pmodul_fi->inceput_afisaj+7);
	PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(pmodul_fi->text_interval_valori,1,arg);

	pune_valori_FI(pmodul_fi);


	pozitia_modul_setari=i;
	if(!pmodul_fi->dialog) /* nu are deja un dialog */
		{
		pmodul_fi->dialog=1;
		ApCreateModule(ABM_setari_fi,NULL,NULL);
		}
	else
		PtWindowToFront(pmodul_fi->window_instance);
	break;
}
}

/* dialog_ao si dialog_do sint functiile apelate inainte de punerea pe ecran
	a modulelor setari_ao si setari_do */
int
dialog_ao( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char r;
	PtArg_t arg[2];
	char buf[15];
	MODUL_AO *pmodul_ao;

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	pmodul_ao=&modul[pozitia_modul_setari].modul_ao;
	pmodul_ao->window_instance=link_instance;
	pmodul_ao->text_setari_ao[0]=ABW_t0;
	pmodul_ao->text_setari_ao[1]=ABW_t1;
	pmodul_ao->text_setari_ao[2]=ABW_t2;
	pmodul_ao->text_setari_ao[3]=ABW_t3;
	pmodul_ao->text_setari_ao[4]=ABW_t4;
	pmodul_ao->text_setari_ao[5]=ABW_t5;
	pmodul_ao->slider_setari_ao[0]=ABW_s0;
	pmodul_ao->slider_setari_ao[1]=ABW_s1;
	pmodul_ao->slider_setari_ao[2]=ABW_s2;
	pmodul_ao->slider_setari_ao[3]=ABW_s3;
	pmodul_ao->slider_setari_ao[4]=ABW_s4;
	pmodul_ao->slider_setari_ao[5]=ABW_s5;

	sprintf(buf,"position=%d",pozitia_modul_setari);
	PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(ABW_text_pozitia_ao,1,arg);

	PtSetArg(&arg[0],Pt_ARG_FLAGS,Pt_BLOCKED,0xffffffff);
	for(r=0;r<6;r++)
		{
		PtSetArg(&arg[1],Pt_ARG_GAUGE_VALUE,10*pmodul_ao->v_AO[r],0);
		PtSetResources(pmodul_ao->slider_setari_ao[r],2,arg);
		}

	for(r=0;r<6;r++)
		{
		sprintf(buf,"%2.1f",pmodul_ao->v_AO[r]);
		PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
		PtSetResources(pmodul_ao->text_setari_ao[r],1,arg);
		}

	return( Pt_CONTINUE );

	}

int
dialog_do( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	PtArg_t arg[1];
	char buf[15],r;
	MODUL_DO *pmodul_do;

	/* eliminate 'unreferenced' warnings */
	apinfo = apinfo, cbinfo = cbinfo;

	pmodul_do=&modul[pozitia_modul_setari].modul_do;
	pmodul_do->window_instance=link_instance;
	pmodul_do->buton_setari_do[0]=ABW_d0;
	pmodul_do->buton_setari_do[1]=ABW_d1;
	pmodul_do->buton_setari_do[2]=ABW_d2;
	pmodul_do->buton_setari_do[3]=ABW_d3;
	pmodul_do->buton_setari_do[4]=ABW_d4;
	pmodul_do->buton_setari_do[5]=ABW_d5;
	pmodul_do->buton_setari_do[6]=ABW_d6;
	pmodul_do->buton_setari_do[7]=ABW_d7;
	pmodul_do->buton_setari_do[8]=ABW_d8;
	pmodul_do->buton_setari_do[9]=ABW_d9;
	pmodul_do->buton_setari_do[10]=ABW_d10;
	pmodul_do->buton_setari_do[11]=ABW_d11;
	pmodul_do->buton_setari_do[12]=ABW_d12;
	pmodul_do->buton_setari_do[13]=ABW_d13;
	pmodul_do->buton_setari_do[14]=ABW_d14;
	pmodul_do->buton_setari_do[15]=ABW_d15;
	pmodul_do->buton_setari_do[16]=ABW_d16;
	pmodul_do->buton_setari_do[17]=ABW_d17;
	pmodul_do->buton_setari_do[18]=ABW_d18;
	pmodul_do->buton_setari_do[19]=ABW_d19;
	pmodul_do->buton_setari_do[20]=ABW_d20;
	pmodul_do->buton_setari_do[21]=ABW_d21;
	pmodul_do->buton_setari_do[22]=ABW_d22;
	pmodul_do->buton_setari_do[23]=ABW_d23;

	sprintf(buf,"position=%d",pozitia_modul_setari);
	PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(ABW_text_pozitia_do,1,arg);

	for(r=0;r<24;r++)
		{
		PtSetArg(&arg[0],Pt_ARG_ONOFF_STATE,pmodul_do->v_DO[r],0);
		PtSetResources(pmodul_do->buton_setari_do[r],1,arg);
		}

	return( Pt_CONTINUE );

	}
int
close_ao( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i;
	MODUL_AO * pmodul_ao;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	for(i=0;i<8;i++)
		if(config[i]==AO)
			{
			pmodul_ao=&modul[i].modul_ao;
			if(pmodul_ao->window_instance==widget)
				{
				/* butonul de pe pozitia i */
				pmodul_ao->dialog=0;
				break;
				}
			}

	if(!pmodul_ao->flag_auto) { kill(pid[i],SIGUSR2);
				    pmodul_ao->flag_auto=1;
				  }

	return( Pt_CONTINUE );

	}

int
close_do( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i;
	MODUL_DO * pmodul_do;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;


	for(i=0;i<8;i++)
		if(config[i]==DO)
			{
			pmodul_do=&modul[i].modul_do;

			if(pmodul_do->window_instance==widget)
				{
				/* butonul de pe pozitia i */
				pmodul_do->dialog=0;
				break;
				}
			}

	if(!pmodul_do->flag_auto) { kill(pid[i],SIGUSR2);
				    pmodul_do->flag_auto=1;
				  }


	return( Pt_CONTINUE );
	}

int close_ai( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
	{
	register char i;
	MODUL_AI * pmodul_ai;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	for(i=0;i<8;i++)
		if(config[i]==AI)
			{
			pmodul_ai=&modul[i].modul_ai;
			if(pmodul_ai->window_instance==widget)
				{
				/* butonul de pe pozitia i */
				pmodul_ai->dialog=0;
				break;
				}
			}

	return( Pt_CONTINUE );
	}
int
dialog_ai( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	MODUL_AI *pmodul_ai;
	PtArg_t arg[1];
	char buf[50];

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	pmodul_ai=&modul[pozitia_modul_setari].modul_ai;
	pmodul_ai->window_instance=link_instance;
	pmodul_ai->rt[0]=ABW_rt0;
	pmodul_ai->rt[1]=ABW_rt1;
	pmodul_ai->rt[2]=ABW_rt2;
	pmodul_ai->rt[3]=ABW_rt3;
	pmodul_ai->rt[4]=ABW_rt4;
	pmodul_ai->rt[5]=ABW_rt5;

	pmodul_ai->start=0;

	sprintf(buf,"Analog input position=%d",pozitia_modul_setari);
	PtSetArg(&arg[0],Pt_ARG_WINDOW_TITLE,buf,0);
	PtSetResources(link_instance,1,arg);

	return( Pt_CONTINUE );

	}
int
help_usp( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;
	PxHelpUrl("/PHOTON/usp/src/HELP/usp.html");
	return( Pt_CONTINUE );

	}


int
dialog_fi( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	MODUL_FI *pmodul_fi;
	PtArg_t arg[1];
	char buf[50];

	/* eliminate 'unreferenced' warnings */
	apinfo = apinfo, cbinfo = cbinfo;

	pmodul_fi=&modul[pozitia_modul_setari].modul_fi;
	pmodul_fi->window_instance=link_instance;
	pmodul_fi->bar[0]=ABW_bar0;
	pmodul_fi->bar[1]=ABW_bar1;
	pmodul_fi->bar[2]=ABW_bar2;
	pmodul_fi->bar[3]=ABW_bar3;
	pmodul_fi->bar[4]=ABW_bar4;
	pmodul_fi->bar[5]=ABW_bar5;
	pmodul_fi->bar[6]=ABW_bar6;
	pmodul_fi->bar[7]=ABW_bar7;
	pmodul_fi->bar[8]=ABW_bar8;
	pmodul_fi->bar[9]=ABW_bar9;
	pmodul_fi->bar[10]=ABW_bar10;
	pmodul_fi->bar[11]=ABW_bar11;
	pmodul_fi->bar[12]=ABW_bar12;
	pmodul_fi->bar[13]=ABW_bar13;
	pmodul_fi->bar[14]=ABW_bar14;
	pmodul_fi->bar[15]=ABW_bar15;

	pmodul_fi->text_scale[0]=ABW_scale0;
	pmodul_fi->text_scale[1]=ABW_scale1;
	pmodul_fi->text_scale[2]=ABW_scale2;
	pmodul_fi->text_scale[3]=ABW_scale3;
	pmodul_fi->text_scale[4]=ABW_scale4;
	pmodul_fi->text_scale[5]=ABW_scale5;
	pmodul_fi->text_scale[6]=ABW_scale6;
	pmodul_fi->text_scale[7]=ABW_scale7;
	pmodul_fi->text_scale[8]=ABW_scale8;
	pmodul_fi->text_scale[9]=ABW_scale9;
	pmodul_fi->text_scale[10]=ABW_scale10;

	sprintf(buf,"Counter input position=%d",pozitia_modul_setari);
	PtSetArg(&arg[0],Pt_ARG_WINDOW_TITLE,buf,0);
	PtSetResources(link_instance,1,arg);

	return( Pt_CONTINUE );

	}

int
close_fi( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i;
	MODUL_FI * pmodul_fi;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	for(i=0;i<8;i++)
		if(config[i]==FI)
			{
			pmodul_fi=&modul[i].modul_fi;
			if(pmodul_fi->window_instance==widget)
				{
				/* butonul de pe pozitia i */
				pmodul_fi->dialog=0;
				break;
				}
			}

	return( Pt_CONTINUE );

	}

void draw_di(PtWidget_t * widget,PhTile_t * damage)
{
register int i,r;
PhPoint_t polygon[32],pos={58,0};
MODUL_DI * pmodul_di;
short int ytopline[6]={17,53,89,125,162,197};
short int ybottomline[6]={35,71,107,143,179,216};

for(i=0;i<8;i++)
  if(config[i]==DI)
	if(modul[i].modul_di.raw==widget)
		break;
pmodul_di=&modul[i].modul_di;

if(pmodul_di->redraw==-1) /* init */
  for(i=0;i<6;i++)
	{
	PgSetStrokeColor(Pg_BLACK);
	PgSetStrokeWidth(1);
	PgDrawILine(58,ytopline[i],474,ytopline[i]);
	PgDrawILine(58,ybottomline[i],474,ybottomline[i]);
	if(i==0) for(r=0;r<15;r++) PgDrawILine(84+r*26,17,84+r*26,216);

	pos.y=36+36*i;
	make_polygon_from_values(polygon,pmodul_di->buffer_data[i]);
	PgSetStrokeColor(Pg_RED);
	PgSetStrokeWidth(3);
	PgDrawPolygon(&polygon,32,&pos,Pg_DRAW_STROKE|Pg_RELATIVE);
	}
else if(pmodul_di->redraw==-2) /* next */
	{
	for(i=0;i<6;i++)
		{
		pos.y=36+36*i;
		make_polygon_from_values(polygon,pmodul_di->old_buffer_data[i]);
		PgSetStrokeColor(PgRGB(254,255,189));
		PgSetStrokeWidth(3);
		PgDrawPolygon(&polygon,32,&pos,Pg_DRAW_STROKE|Pg_RELATIVE);
		}

	PgSetStrokeColor(Pg_BLACK);
	PgSetStrokeWidth(1);
	for(r=0;r<15;r++) PgDrawILine(84+r*26,17,84+r*26,216);

	for(i=0;i<6;i++)
		{
		pos.y=36+36*i;
		PgSetStrokeColor(Pg_BLACK);
		PgSetStrokeWidth(1);
		PgDrawILine(58,ytopline[i],474,ytopline[i]);
		PgDrawILine(58,ybottomline[i],474,ybottomline[i]);
	
		make_polygon_from_values(polygon,pmodul_di->buffer_data[i]);
		PgSetStrokeColor(Pg_RED);
		PgSetStrokeWidth(3);
		PgDrawPolygon(&polygon,32,&pos,Pg_DRAW_STROKE|Pg_RELATIVE);
		}
	}
else /* shift */
	{
	pos.y=36+36*pmodul_di->redraw;
	make_polygon_from_values(polygon,pmodul_di->old_buffer_data[pmodul_di->redraw]);
	PgSetStrokeColor(PgRGB(254,255,189));
	PgSetStrokeWidth(3);
	PgDrawPolygon(&polygon,32,&pos,Pg_DRAW_STROKE|Pg_RELATIVE);

	PgSetStrokeColor(Pg_BLACK);
	PgSetStrokeWidth(1);
	PgDrawILine(58,ytopline[pmodul_di->redraw],474,ytopline[pmodul_di->redraw]);
	PgDrawILine(58,ybottomline[pmodul_di->redraw],474,ybottomline[pmodul_di->redraw]);

	make_polygon_from_values(polygon,pmodul_di->buffer_data[pmodul_di->redraw]);
	PgSetStrokeColor(Pg_RED);
	PgSetStrokeWidth(3);
	PgDrawPolygon(&polygon,32,&pos,Pg_DRAW_STROKE|Pg_RELATIVE);
	}

pmodul_di->redraw=-1;
}


int
dialog_di( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register int k;
	MODUL_DI *pmodul_di;
	PtArg_t arg[3];
	char buf[50];
	PhPoint_t pos;
	PhDim_t dim;

	/* eliminate 'unreferenced' warnings */
	apinfo = apinfo, cbinfo = cbinfo;

	pmodul_di=&modul[pozitia_modul_setari].modul_di;
	pmodul_di->window_instance=link_instance;

	pmodul_di->redraw=-1;

	dim.w=418;dim.h=200;
	PtSetArg(&arg[0],Pt_ARG_DIM,&dim,0);
	pos.x=57;pos.y=17;
	PtSetArg(&arg[1],Pt_ARG_POS,&pos,0);
	PtSetArg(&arg[2],Pt_ARG_RAW_DRAW_F,&draw_di,1);
	pmodul_di->raw=PtCreateWidget(PtRaw,link_instance,3,arg);

	sprintf(buf,"Digital input position=%d",pozitia_modul_setari);
	PtSetArg(&arg[0],Pt_ARG_WINDOW_TITLE,buf,0);
	PtSetResources(link_instance,1,arg);


        for(k=0;k<6;k++)
                {
                sprintf(buf,"Ch%2d",k+pmodul_di->start);
                PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,buf,0);
                PtSetResources(ApGetWidgetPtr(ApGetInstance(link_instance),
                        k==0?ABN_di_ch0:k==1?ABN_di_ch1:k==2?ABN_di_ch2:k==3?ABN_di_ch3:k==4?
                                ABN_di_ch4:ABN_di_ch5),
                        1,arg);
                }

	return( Pt_CONTINUE );
	}

void make_polygon_from_values(PhPoint_t *polygon,short int *buffer_data)
{
register int i,j;

/* buffer_data => polygon[] */
polygon[0].x=0;
if(buffer_data[0])
	polygon[0].y=-17;
else	polygon[0].y=0;

for(i=1;i<32;i++)
  {
  if(i%2)
	{
	polygon[i].x=26;
	polygon[i].y=0;
	}
  else
	{
	polygon[i].x=0;
  	j=i>>1;
  	if(buffer_data[j]!=buffer_data[j-1])
  		polygon[i].y=(buffer_data[j]?-1:1)*17;
  	else
		polygon[i].y=0;
	}
  }
}



int
close_di( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	register char i;
	MODUL_DI * pmodul_di;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	for(i=0;i<8;i++)
		if(config[i]==DI)
			{
			pmodul_di=&modul[i].modul_di;
			if(pmodul_di->window_instance==widget)
				{
				/* butonul de pe pozitia i */
				pmodul_di->dialog=0;
				break;
				}
			}

	return( Pt_CONTINUE );
	}
